//Spat.cs
//Pandan - Alt fire snippet from Ephi. Thanks, i think?
//Script cleaned by Racer. You left your fucking vacuum at my house! :(


datablock AudioProfile(SpatHitSound)
{
   filename = "Add-Ons/Weapon_Bow/arrowHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock ParticleData(SpatStarBoomParticle)
{
   dragCoefficient		= 0.4;
   windCoefficient		= 0.0;
   gravityCoefficient	= -0.5;
   inheritedVelFactor	= 0.2;
   constantAcceleration	= 0.0;
   lifetimeMS		= 100;
   lifetimeVarianceMS	= 15;
   spinSpeed		= 10;
   spinRandomMin	= -1000.0;
   spinRandomMax	= 1000.0;
   useInvAlpha		= false;
   animateTexture	= false;
   textureName	= "base/data/particles/star1";
   colors[0]	= "1 0 0 1";
   colors[1]	= "1 1 0 0";
   sizes[0]	= 5;
   sizes[1]	= 7;
};

datablock ParticleEmitterData(SpatStarBoomEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   lifeTimeMS	   = 250;
   ejectionVelocity = 25;
   velocityVariance = 5;
   ejectionOffset   = 3;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpatStarBoomParticle";
};


datablock ParticleData(SpatDebFireParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -1;
   inheritedVelFactor   = 1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -150.0;
   spinRandomMax		= 150.0;
   colors[0]     = "1 0.5 0 0.4";
   colors[1]     = "1 0.2 0 0.3";
   colors[2]     = "1 0 0 0";
   sizes[0]      = 0.3;
   sizes[1]      = 0.25;
   sizes[2]      = 0.15;
	useInvAlpha = false;
};
datablock ParticleEmitterData(SpatDebFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0.5;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpatDebFireParticle";
};

datablock DebrisData(SpatDebris)
{
   emitters = "SpatDebFireEmitter";

   shapeFile = "base/data/shapes/empty.dts";
   lifetime = 0.7;
   lifetimeVariance = 0.3;
   minSpinSpeed = 0;
   maxSpinSpeed = 1;
   elasticity = 0.3;
   friction = 0.2;
   numBounces = 5;
   staticOnMaxBounce = true;
   fade = true;
   gravModifier = 2;
};

//muzzle flash effects
datablock ParticleData(SpatExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 30.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.5 0 0.9";
	colors[1]     = "1 0.5 0 0.0";
	sizes[0]      = 5.0;
	sizes[1]      = 5.0;

	useInvAlpha = false;
};

datablock ParticleData(SpatFlashParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.5 0.0 0.9";
	colors[1]     = "1.0 0.5 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};

datablock ParticleData(SpatSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.2";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};

datablock ParticleData(SpatTrailParticleB)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0 0.2";
	colors[1]     = "1 0.5 0 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.4;

	useInvAlpha = false;
};

datablock ParticleEmitterData(SpatFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpatFlashParticle";
};


datablock ParticleEmitterData(SpatSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpatSmokeParticle";
};

//trails

datablock ParticleEmitterData(SpatTrailEmitterB)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpatTrailParticleB";
};


datablock ParticleEmitterData(SpatExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpatExplosionRingParticle";
};


datablock ParticleEmitterData(SpatExplosionRingEmitter)
{
	lifeTimeMS = 50;

   	ejectionPeriodMS = 1;
   	periodVarianceMS = 0;
   	ejectionVelocity = 5;
   	velocityVariance = 0.0;
   	ejectionOffset   = 0.0;
   	thetaMin         = 89;
   	thetaMax         = 90;
   	phiReferenceVel  = 0;
   	phiVariance      = 360;
   	overrideAdvance = false;
   	particles = "SpatExplosionRingParticle";
};



datablock ExplosionData(SpatExplosion)
{
//   explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = SpatExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   debris = SpatDebris;
   debrisNum = 10;
   debrisNumVariance = 5;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 75;
   debrisVelocityVariance = 10;

   emitter[0] = SpatExplosionRingEmitter;
   emitter[1] = SpatStarBoomEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 1";

   damageRadius = 5.0;
   radiusDamage = 40;

   impulseRadius = 1;
   impulseForce = 2000;
};

//Projectiles
AddDamageType("SpatShellDirect",   '<bitmap:add-ons/Weapon_Spat/CI_Spat> %1',    '%2 <bitmap:add-ons/Weapon_Spat/CI_Spat> %1',0.2,1);
datablock ProjectileData(SpatProjectileA)
{
   projectileShapeName = "./Spatbullet.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::SpatShellDirect;
   radiusDamageType    = $DamageType::SpatShellRadius;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 1000;
   verticalImpulse     = 0;
   explosion           = SpatExplosion;
   particleEmitter     = SpatTrailEmitterB;

   muzzleVelocity      = 180;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 3000;
   fadeDelay           = 5000;
   bounceElasticity    = 0.0;
   bounceFriction      = 1;
   isBallistic         = true;
   gravityMod = 1.0;
   explodeOnDeath = true;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "1.0 0.5 0";
   uiName = "Spat Bullet";
};


//Item
datablock ItemData(SpatItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Spat.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Spat";
	iconName = "./Spat";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = SpatImage;
	canDrop = true;
};

//Image
datablock ShapeBaseImageData(SpatImage)
{
   // Basic Item properties
   shapeFile = "./Spat.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SpatItem;
   ammo = " ";
   projectile = SpatProjectileA;
   projectileType = Projectile;
   minShotTime = 200;   //No exploit prevention here! :D

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = SpatItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
        stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= SpatSmokeEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateSequence[3]                = "Reload";
	stateTimeoutValue[3]            = 1.5;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";

};